/*****************************************************************************

                   ACC22 - a 22 line desk accessory 
                written for Screenfull by Les Kneeling
                            in Laser C

    The accessory puts 'Hard Reset' into the menu bar. 
    No prizes for guessing what happens when you click on it....

    The value in memvalid is changed before the reset to fool the ST
    into doing a hard reset instead of a soft one.

*****************************************************************************/

extern gl_apid;

main()
{
int event, msgbuff[8];
appl_init();                            /* Initialise ROMs          */
menu_register( gl_apid, "  Hard Reset" );
do  {
    event = evnt_mesag(msgbuff );       /* Look for messages        */
    if( msgbuff[0] == 40 )              /* 40 is AC_OPEN            */
        asm {
            clr.l   -(A7)   
            move.w #0x20,-(A7)
            trap #1
            addq.l  #6,A7
            clr.l   0x420               /* 0x420 is memvalid        */
            move.l  0x4,A0              
            jmp     (A0)
            }
    }while(1);                          /* Another way of saying 'forever'*/
}
